Create Root Test Suite Entity
POST {{apiPath}}/test-suite/roots/{{testSuiteType}}?branch={{branchId}}
The POST /test-suite/roots/{{testSuiteType}} operation creates a new root test suite entity. The allowable values for {{testSuiteType}} are TEST_SCENARIO, TEST_CASE, or ASSERTION. The request must provide either a branch ID or a snapshot ID in the request URL to specify where the test suite entity should be created.
Prerequisites
-
Create a branch to get a branch ID.
-
Create a snapshot to get a snapshot ID.
Query parameters
| Query parameter | Description |
|---|---|
|
Branch ID or name |
|
Snapshot ID |
Request Model
For property descriptions, refer to Test suite data model.
Test Scenario Request Model
| Property | Type | Required |
|---|---|---|
|
String |
Required |
|
String |
Optional |
|
JSON[] |
Optional |
|
Boolean |
Optional |
|
String |
Optional |
|
String |
Optional |
|
String |
Optional |
|
String |
Optional |
|
JSON |
Optional |
|
JSON |
Optional |
To create an test scenario group rather than an individual test scenario, set the testScenario property to null.
Test case request model
| Property | Type | Required |
|---|---|---|
|
String |
Required |
|
String |
Optional |
|
JSON[] |
Optional |
|
Boolean |
Optional |
|
Required |
|
|
Optional |
|
|
String |
Optional |
|
String |
Optional |
|
String |
Optional |
|
String |
Optional |
|
String |
Optional |
|
JSON |
Optional |
|
JSON |
Optional |
To create an test case group rather than an individual test case, set the testCase property to null.
Assertion data model
| Property | Type | Required |
|---|---|---|
|
String |
Required |
|
String |
Optional |
|
JSON[] |
Optional |
|
Boolean |
Optional |
|
String |
Required |
|
String |
Optional |
|
String |
Required |
|
String |
Required |
To create an assertion group rather than an individual assertion, set the assertion property to null.
Body
raw ( application/json )
{
"name": "assertion-example-1",
"description": "",
"numberOfChildren": 0,
"objectType": "AssertionDefinition",
"permissions": {
"inherit": true,
"rolePermissions": []
},
"assertion": {
"type": "json-path",
"accessor": "$.value",
"comparator": "Equals",
"expectation": {
"valueType": "STRING",
"value": "123"
}
}
}
Example Request
-
cURL
-
C#
-
Go
-
HTTP
-
Java
-
jQuery
-
NodeJS
-
Python
-
PHP
-
Ruby
-
Swift
curl --location --globoff '{{apiPath}}/test-suite/roots/{{testSuiteType}}?branch={{branchId}}' \
--header 'x-user-id: {{userId}}' \
--header 'Content-Type: application/json' \
--data '{
"name": "assertion-example-1",
"description": "",
"numberOfChildren": 0,
"objectType": "AssertionDefinition",
"permissions": {
"inherit": true,
"rolePermissions": []
},
"assertion": {
"type": "json-path",
"accessor": "$.value",
"comparator": "Equals",
"expectation": {
"valueType": "STRING",
"value": "123"
}
}
}'
var options = new RestClientOptions("{{apiPath}}/test-suite/roots/{{testSuiteType}}?branch={{branchId}}")
{
MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("x-user-id", "{{userId}}");
request.AddHeader("Content-Type", "application/json");
var body = @"" + "\n" +
@" {" + "\n" +
@" ""name"": ""assertion-example-1""," + "\n" +
@" ""description"": """"," + "\n" +
@" ""numberOfChildren"": 0," + "\n" +
@" ""objectType"": ""AssertionDefinition""," + "\n" +
@" ""permissions"": {" + "\n" +
@" ""inherit"": true," + "\n" +
@" ""rolePermissions"": []" + "\n" +
@" }," + "\n" +
@" ""assertion"": {" + "\n" +
@" ""type"": ""json-path""," + "\n" +
@" ""accessor"": ""$.value""," + "\n" +
@" ""comparator"": ""Equals""," + "\n" +
@" ""expectation"": {" + "\n" +
@" ""valueType"": ""STRING""," + "\n" +
@" ""value"": ""123""" + "\n" +
@" }" + "\n" +
@" }" + "\n" +
@" }";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "{{apiPath}}/test-suite/roots/{{testSuiteType}}?branch={{branchId}}"
method := "POST"
payload := strings.NewReader(`{
"name": "assertion-example-1",
"description": "",
"numberOfChildren": 0,
"objectType": "AssertionDefinition",
"permissions": {
"inherit": true,
"rolePermissions": []
},
"assertion": {
"type": "json-path",
"accessor": "$.value",
"comparator": "Equals",
"expectation": {
"valueType": "STRING",
"value": "123"
}
}
}`)
client := &http.Client {
}
req, err := http.NewRequest(method, url, payload)
if err != nil {
fmt.Println(err)
return
}
req.Header.Add("x-user-id", "{{userId}}")
req.Header.Add("Content-Type", "application/json")
res, err := client.Do(req)
if err != nil {
fmt.Println(err)
return
}
defer res.Body.Close()
body, err := io.ReadAll(res.Body)
if err != nil {
fmt.Println(err)
return
}
fmt.Println(string(body))
}
POST /test-suite/roots/{{testSuiteType}}?branch={{branchId}} HTTP/1.1
Host: {{apiPath}}
x-user-id: {{userId}}
Content-Type: application/json
{
"name": "assertion-example-1",
"description": "",
"numberOfChildren": 0,
"objectType": "AssertionDefinition",
"permissions": {
"inherit": true,
"rolePermissions": []
},
"assertion": {
"type": "json-path",
"accessor": "$.value",
"comparator": "Equals",
"expectation": {
"valueType": "STRING",
"value": "123"
}
}
}
OkHttpClient client = new OkHttpClient().newBuilder()
.build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "\n {\n \"name\": \"assertion-example-1\",\n \"description\": \"\",\n \"numberOfChildren\": 0,\n \"objectType\": \"AssertionDefinition\",\n \"permissions\": {\n \"inherit\": true,\n \"rolePermissions\": []\n },\n \"assertion\": {\n \"type\": \"json-path\",\n \"accessor\": \"$.value\",\n \"comparator\": \"Equals\",\n \"expectation\": {\n \"valueType\": \"STRING\",\n \"value\": \"123\"\n }\n }\n }");
Request request = new Request.Builder()
.url("{{apiPath}}/test-suite/roots/{{testSuiteType}}?branch={{branchId}}")
.method("POST", body)
.addHeader("x-user-id", "{{userId}}")
.addHeader("Content-Type", "application/json")
.build();
Response response = client.newCall(request).execute();
var settings = {
"url": "{{apiPath}}/test-suite/roots/{{testSuiteType}}?branch={{branchId}}",
"method": "POST",
"timeout": 0,
"headers": {
"x-user-id": "{{userId}}",
"Content-Type": "application/json"
},
"data": JSON.stringify({
"name": "assertion-example-1",
"description": "",
"numberOfChildren": 0,
"objectType": "AssertionDefinition",
"permissions": {
"inherit": true,
"rolePermissions": []
},
"assertion": {
"type": "json-path",
"accessor": "$.value",
"comparator": "Equals",
"expectation": {
"valueType": "STRING",
"value": "123"
}
}
}),
};
$.ajax(settings).done(function (response) {
console.log(response);
});
var request = require('request');
var options = {
'method': 'POST',
'url': '{{apiPath}}/test-suite/roots/{{testSuiteType}}?branch={{branchId}}',
'headers': {
'x-user-id': '{{userId}}',
'Content-Type': 'application/json'
},
body: JSON.stringify({
"name": "assertion-example-1",
"description": "",
"numberOfChildren": 0,
"objectType": "AssertionDefinition",
"permissions": {
"inherit": true,
"rolePermissions": []
},
"assertion": {
"type": "json-path",
"accessor": "$.value",
"comparator": "Equals",
"expectation": {
"valueType": "STRING",
"value": "123"
}
}
})
};
request(options, function (error, response) {
if (error) throw new Error(error);
console.log(response.body);
});
import requests
import json
url = "{{apiPath}}/test-suite/roots/{{testSuiteType}}?branch={{branchId}}"
payload = json.dumps({
"name": "assertion-example-1",
"description": "",
"numberOfChildren": 0,
"objectType": "AssertionDefinition",
"permissions": {
"inherit": True,
"rolePermissions": []
},
"assertion": {
"type": "json-path",
"accessor": "$.value",
"comparator": "Equals",
"expectation": {
"valueType": "STRING",
"value": "123"
}
}
})
headers = {
'x-user-id': '{{userId}}',
'Content-Type': 'application/json'
}
response = requests.request("POST", url, headers=headers, data=payload)
print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/test-suite/roots/{{testSuiteType}}?branch={{branchId}}');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
'follow_redirects' => TRUE
));
$request->setHeader(array(
'x-user-id' => '{{userId}}',
'Content-Type' => 'application/json'
));
$request->setBody('{\n "name": "assertion-example-1",\n "description": "",\n "numberOfChildren": 0,\n "objectType": "AssertionDefinition",\n "permissions": {\n "inherit": true,\n "rolePermissions": []\n },\n "assertion": {\n "type": "json-path",\n "accessor": "$.value",\n "comparator": "Equals",\n "expectation": {\n "valueType": "STRING",\n "value": "123"\n }\n }\n }');
try {
$response = $request->send();
if ($response->getStatus() == 200) {
echo $response->getBody();
}
else {
echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
$response->getReasonPhrase();
}
}
catch(HTTP_Request2_Exception $e) {
echo 'Error: ' . $e->getMessage();
}
require "uri"
require "json"
require "net/http"
url = URI("{{apiPath}}/test-suite/roots/{{testSuiteType}}?branch={{branchId}}")
http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["x-user-id"] = "{{userId}}"
request["Content-Type"] = "application/json"
request.body = JSON.dump({
"name": "assertion-example-1",
"description": "",
"numberOfChildren": 0,
"objectType": "AssertionDefinition",
"permissions": {
"inherit": true,
"rolePermissions": []
},
"assertion": {
"type": "json-path",
"accessor": "\$.value",
"comparator": "Equals",
"expectation": {
"valueType": "STRING",
"value": "123"
}
}
})
response = http.request(request)
puts response.read_body
let parameters = "{\n \"name\": \"assertion-example-1\",\n \"description\": \"\",\n \"numberOfChildren\": 0,\n \"objectType\": \"AssertionDefinition\",\n \"permissions\": {\n \"inherit\": true,\n \"rolePermissions\": []\n },\n \"assertion\": {\n \"type\": \"json-path\",\n \"accessor\": \"$.value\",\n \"comparator\": \"Equals\",\n \"expectation\": {\n \"valueType\": \"STRING\",\n \"value\": \"123\"\n }\n }\n }"
let postData = parameters.data(using: .utf8)
var request = URLRequest(url: URL(string: "{{apiPath}}/test-suite/roots/{{testSuiteType}}?branch={{branchId}}")!,timeoutInterval: Double.infinity)
request.addValue("{{userId}}", forHTTPHeaderField: "x-user-id")
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.httpMethod = "POST"
request.httpBody = postData
let task = URLSession.shared.dataTask(with: request) { data, response, error in
guard let data = data else {
print(String(describing: error))
return
}
print(String(data: data, encoding: .utf8)!)
}
task.resume()
Example Response
201 Created
{
"objectType": "AssertionDefinition",
"id": "0c9bffec-a65d-486f-b071-07956cad0362",
"version": "37988047-b75c-4be6-bbe8-40832cd90a03",
"type": "ASSERTION",
"name": "assertion-example-1",
"fullName": "assertion-example-1",
"description": "",
"parentId": null,
"numberOfChildren": 0,
"permissions": {
"inherit": true,
"rolePermissions": []
},
"assertion": {
"type": "json-path",
"name": null,
"accessor": "$.value",
"comparator": "Equals",
"expectation": {
"value": "123",
"valueType": "STRING"
}
},
"properties": []
}